##
##  dhcpd.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_opkg 4.4.3p1
%define       V_dist 4.4.3-P1

#   package information
Name:         dhcpd
Summary:      DHCP Daemon
URL:          http://www.isc.org/products/DHCP/
Vendor:       Internet Software Consortium
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        BASE
Group:        DHCP
License:      ISC/BSD
Version:      %{V_opkg}
Release:      20221007

#   package options
%option       with_fsl  yes

#   list of sources
Source0:      ftp://ftp.isc.org/isc/dhcp/%{V_dist}/dhcp-%{V_dist}.tar.gz
Source1:      dhcpd.conf
Source2:      rc.dhcpd
Source3:      fsl.dhcpd

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101
PreReq:       OpenPKG, openpkg >= 20160101
BuildPreReq:  openssl
PreReq:       openssl
%if "%{with_fsl}" == "yes"
BuildPreReq:  fsl
PreReq:       fsl
%endif

%description
    This is the ISC DHCP daemon reference implementation.

%track
    prog dhcpd = {
        version   = %{V_dist}
        url       = ftp://ftp.isc.org/isc/dhcp/
        regex     = (\d+\.\d+\.\d+(-P\d+)?)\s
    }

%prep
    %setup -q -n dhcp-%{V_dist}

%build
    #   configure program
    %{l_shtool} subst \
        -e 's;^[^#]*\(#define[^_]*_PATH_DHCPD_PID[^"]*\).*;\1 "%{l_prefix}/var/dhcpd/run/dhcpd.pid";' \
        -e 's;^[^#]*\(#define[^_]*_PATH_DHCPD_DB[^"]*\).*;\1 "%{l_prefix}/var/dhcpd/db/dhcpd.leases";' \
        -e 's;^[^#]*\(#define[^_]*_PATH_DHCPD_CONF[^"]*\).*;\1 "%{l_prefix}/etc/dhcpd/dhcpd.conf";' \
        includes/site.h
    CC="%{l_cc}" \
    CFLAGS="%{l_cflags -O}" \
    CPPFLAGS="%{l_cppflags} -DNOMINUM" \
    LDFLAGS="%{l_ldflags} %{l_fsl_ldflags}" \
    LIBS="%{l_fsl_libs}" \
    ./configure \
        --prefix=%{l_prefix} \
        --mandir=%{l_prefix}/man \
        --sysconfdir=%{l_prefix}/etc/dhcpd \
        --localstatedir=%{l_prefix}/var/dhcpd \
        --with-srv-lease-file=%{l_prefix}/var/dhcpd/db/dhcpd.leases \
        --with-cli-lease-file=%{l_prefix}/var/dhcpd/db/dhclient.leases \
        --with-srv-pid-file=%{l_prefix}/var/dhcpd/run/dhcpd.pid \
        --with-cli-pid-file=%{l_prefix}/var/dhcpd/run/dhclient.pid \
        --with-relay-pid-file=%{l_prefix}/var/dhcpd/run/dhrelay.pid \
        --disable-silent-rules \
        --disable-dhcpv6

    #   build program
    %{l_make} %{l_mflags}

%install
    #   install program
    %{l_make} %{l_mflags} install DESTDIR=$RPM_BUILD_ROOT

    #   install default configuration
    %{l_shtool} install -c -m 644 \
        %{SOURCE dhcpd.conf} \
        $RPM_BUILD_ROOT%{l_prefix}/etc/dhcpd/dhcpd.conf

    #   post-adjust and strip down installation
    rm -f $RPM_BUILD_ROOT%{l_prefix}/etc/dhcpd/*.example
    rm -f $RPM_BUILD_ROOT%{l_prefix}/sbin/dhclient-script
    rm -f $RPM_BUILD_ROOT%{l_prefix}/man/man8/dhclient-script.8
    strip $RPM_BUILD_ROOT%{l_prefix}/bin/*  2>/dev/null || true
    strip $RPM_BUILD_ROOT%{l_prefix}/sbin/* 2>/dev/null || true

    #   install run-command script
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        %{SOURCE rc.dhcpd} $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d/

    #   install OSSP fsl configuration
    %{l_shtool} mkdir -f -p -m 755 $RPM_BUILD_ROOT%{l_prefix}/etc/fsl
    %{l_shtool} install -c -m 644 %{l_value -s -a} \
        %{SOURCE fsl.dhcpd} \
        $RPM_BUILD_ROOT%{l_prefix}/etc/fsl/

    #   create run-time directories
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/var/dhcpd/db \
        $RPM_BUILD_ROOT%{l_prefix}/var/dhcpd/run \
        $RPM_BUILD_ROOT%{l_prefix}/var/dhcpd/log

    #   determine installation files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT \
        %{l_files_std} \
        '%config %{l_prefix}/etc/fsl/fsl.dhcpd' \
        '%config %{l_prefix}/etc/dhcpd/*'

%files -f files

%clean

%post
    if [ $1 -eq 1 ]; then
        #   display final hints on initial installation
        ( echo "Before starting DHCP daemon, please set the configuration variable"
          echo "\"dhcpd_if\" in $RPM_INSTALL_PREFIX/etc/rc.conf to the name of the"
          echo "used network interface."
        ) | %{l_rpmtool} msg -b -t notice
    fi

    #   after upgrade, restart service
    [ $1 -eq 2 ] || exit 0
    eval `%{l_rc} dhcpd status 2>/dev/null`
    [ ".$dhcpd_active" = .yes ] && %{l_rc} dhcpd restart
    exit 0

%preun
    #   before erase, stop service and remove log files
    [ $1 -eq 0 ] || exit 0
    %{l_rc} dhcpd stop 2>/dev/null
    rm -f $RPM_INSTALL_PREFIX/var/dhcpd/db/*  >/dev/null 2>&1 || true
    rm -f $RPM_INSTALL_PREFIX/var/dhcpd/run/* >/dev/null 2>&1 || true
    exit 0

